<?php

use EventPortal\Domain\Event\Form\Enums\QuestionType;
use EventPortal\Domain\Event\Form\Models\FormStepSection;
use EventPortal\Domain\Event\Form\Models\Question;
use Faker\Generator as Faker;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(Question::class, static function (Faker $faker): array {
    static $count = 0;
    return [
        'question' => $faker->sentence(5),
        'type' => QuestionType::SingleLineTextBox(),
        'is_sensitive_personal_data' => false,
        'order' => $count = $count + 1,
        'form_step_section_id' => static function (): int {
            return factory(FormStepSection::class)->create()->id;
        },
        'uuid' => $faker->uuid,
    ];
});

$factory->state(Question::class, 'help', static function (Faker $faker): array {
    return [
        'help_text' => $faker->sentence,
    ];
});

$factory->state(Question::class, 'snapshot', static function (): array {
    return [
        'question' => 'Test Question',
        'type' => QuestionType::SingleLineTextBox(),
        'is_sensitive_personal_data' => false,
        'order' => 1,
        'help_text' => 'Test Help',
        'placeholder' => 'Test Placeholder',
        'form_step_section_id' => static function (): int {
            return factory(FormStepSection::class)->state('snapshot')->create()->id;
        },
        'uuid' => 'Test uuid',
    ];
});

$factory->state(Question::class, 'gdpr', static function (): array {
    return [
        'is_sensitive_personal_data' => true,
    ];
});

$factory->state(Question::class, 'placeholder', static function (Faker $faker): array {
    return [
        'placeholder' => $faker->sentence,
    ];
});
