<?php

namespace EventPortal\Domain\Util\Notification\Models;

use EventPortal\Concerns\HasStatus;
use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Model;
use Iben\Statable\Statable;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class EventNotification extends Model
{
    use HasStatus, Statable;

    protected $table = 'event_notifications';

    /** @var array<string> */
    protected $fillable = [
        'delegate_id',
        'event_id',
        'method',
        'key',
        'status',
    ];

    public function delegate(): BelongsTo
    {
        return $this->belongsTo(Delegate::class);
    }

    public function event(): BelongsTo
    {
        return $this->belongsTo(Event::class);
    }

    protected function getGraph(): string
    {
        return 'eventNotification';
    }

    public function transitionRouteName(): string
    {
        return 'admin.event.notification.transition';
    }
}
